# TODO: FIFO buffer
# port mapped I/O does not care about paging

.set PORT, 0x3F8 // COM1

.set TRANSMITTER_HOLDING_REGISTER, 0 // write-only
.set INTERRUPT_ENABLE_REGISTER, 1
.set FIFO_CONTROL_REGISTER, 2 // write-only
.set LINE_CONTROL_REGISTER, 3
.set LINE_STATUS_REGISTER, 5

.set TRANSMITTER_HOLDING_REGISTER_EMPTY, 0x20



.global uart_init
uart_init:
        # TODO: for now we just block (we only write to register)
        # disable all interrupts
        movq    $(PORT + INTERRUPT_ENABLE_REGISTER), %rdx
        movq    $0x0, %rax
        outb    %al, (%dx)

        movq    $(PORT + LINE_CONTROL_REGISTER), %rdx
        movq    $0x03, %rax # 8 bits per character, no parity
        outb    %al, (%dx)

        ret



# blocking
.global uart_write
uart_write:
        call wait
        movq    $PORT, %rdx
        movq    (%rdi), %rax
        testb   $0xFF, (%rdi)
        jz exit
        outb    %al, (%dx)
        inc     %rdi
        jmp uart_write
exit:
        ret



wait:
        movq    $(PORT + LINE_STATUS_REGISTER), %rdx
        inb     (%dx), %al
        testb   $TRANSMITTER_HOLDING_REGISTER_EMPTY, %al
        jz      wait
        ret
