#ifndef CONTAINER_H
#define CONTAINER_H

#include <lib/type.h>

#include "spinlock.h"


uint64_t const container_none = -1;

enum status {
        status_runnable,
        status_running,
};


// TODO: use offsetof?
struct registers {
        uint64_t rip;
        uint64_t rsp;
};

struct container {
        enum status status;
        struct registers regs;
        struct page_table *pml4;
        uint64_t penalty;
        uint64_t de_fault;
        uint64_t ud_fault;
        uint64_t gp_fault;
        uint64_t pf_fault;
        uint64_t xf_fault;
        uint64_t timer_interrupt;
};

// TODO: should we have this structure for each core separately?
// TODO: use bitmap
struct containers {
        struct container *data;
        uint64_t count;
        uint64_t capacity;
        struct spinlock lock;
};


#endif
