#ifndef KERNEL_CORE_H
#define KERNEL_CORE_H

#include <lib/type.h>

#include "amd64.h"


// per core
enum { quanta_capacity = 256 };
struct quanta {
        uint64_t idxs[quanta_capacity];
        uint64_t offset, end_offset;
};


// TODO: put on heap?
// offset into cpus is stored in GS:q
enum { core_limit = 64 };
// TODO: likely cache unfriendly
static struct core {
        // must be first three entries
        // these entries are at fixed offset to simplify the assembly code
        uint64_t rsp_kernel;
        uint64_t rsp_user; // needed for user space
        uint64_t rip_timer_interrupt; // user mode timer interrupt handler; TODO: do the indirections to get it from quantum?
        uint64_t tsc_rate_ms;

        struct quanta quanta;
        struct spinlock lock;
        uint64_t stack_address;
        uint64_t stack_size;
        struct idt *idt;
        struct gdt *gdt;
        struct tss *tss;
        volatile bool running;
} cores[core_limit];


#endif
