/* inspired by JOS kernel */

/* canonical address form */
KERNEL_BASE = 0xFFFFFF8000000000;

OUTPUT_FORMAT(elf64-x86-64)
OUTPUT_ARCH(i386:x86-64)
ENTRY(_start)

/* by default linker would put .text and .rodata into one read and execute segment */
PHDRS
{
        text    PT_LOAD FLAGS(5); /* read and execute */
        rodata  PT_LOAD FLAGS(4); /* read */
        data    PT_LOAD FLAGS(6); /* read and write */
}


SECTIONS
{
        /* link kernel at this addrees; '.' means the current address
           we keep the first MB unused as we should not overwrite it
           MUST BE SAME AS KERNEL_BASE */
        . = KERNEL_BASE;

        /* load address of this section, i.e., where we load the kernel */
        . = ALIGN(0x200000);
        .text : {
                *(.text)
        } : text

        PROVIDE(etext = .);

        . = ALIGN(0x200000);
        PROVIDE(rodata = . );
        .rodata : {
                *(.rodata*) /* TODO: why asterisk at the end? */
        } : rodata

        PROVIDE(erodata = .);

        . = ALIGN(0x200000);
        PROVIDE(data = . );
        .data : {
                *(.data)
        } : data

        PROVIDE(edata = .);

        /* I don't like .bss */
        PROVIDE(bss = . );
        .bss : {
                *(.bss)
        }

        PROVIDE(end = .);


        /DISCARD/ : {
                *(.comment .eh_frame)
        }
}
