// ELF-64 structures

#ifndef ELF_H
#define ELF_H

#include "type.h"


#define ELF_PF_X 0x1ul // execute permission
#define ELF_PF_W 0x2ul // write permission

enum elf_section_type {elf_sht_symtab = 2};


// TODO: properly name members? (currently it is copy from spec)
struct elf_file_header {
        uint8_t ident[16];
        uint16_t type;
        uint16_t machine;
        uint32_t version;
        uint64_t entry;
        uint64_t phoff;
        uint64_t shoff;
        uint32_t flags;
        uint16_t ehsize;
        uint16_t phentsize;
        uint16_t phnum;
        uint16_t shentsize;
        uint16_t shnum;
        uint16_t shstrndx;
};


struct elf_section_header {
        uint32_t name;
        uint32_t type;
        uint64_t flags;
        uint64_t addr;
        uint64_t offset;
        uint64_t size;
        uint32_t link;
        uint32_t info;
        uint64_t addralign;
        uint64_t entsize;
};


struct elf_symbol {
        uint32_t name;
        uint8_t info;
        uint8_t other;
        uint16_t shndx;
        uint64_t value;
        uint64_t size;
};


struct elf_program_header {
        uint32_t type;
        uint32_t flags;
        uint64_t offset;
        uint64_t vaddr;
        uint64_t paddr;
        uint64_t filesz;
        uint64_t memsz;
        uint64_t align;
};


#endif
