#ifndef LIB_H
#define LIB_H


void *
memset(void *const ptr, int64_t const value, uint64_t const num)
{
        uint8_t *const tmp = ptr;
        for (uint64_t i = 0; i < num; ++i)
                tmp[i] = value;
        return ptr;
}


void *
memcpy(void *const dst, void const *const src, uint64_t const num)
{
        for (uint64_t i = 0; i < num; ++i)
                ((uint8_t*)dst)[i] = ((uint8_t *)src)[i];
        return dst;
}


static inline int
strcmp(char const *const str0, char const *const str1)
{
        for (uint64_t i = 0;; ++i) {
                if (str0[i] != str1[i] || str0[i] == '\0' || str1[i] == '\0')
                        return str0[i] - str1[i];
        }
        return 0;
}


// because C sucks
struct args {
        int dummy;
        union {
                uint64_t num;
                char *str;
        } data[16];
};
#define SPRINTF(count, buffer, format, ...) sprintf(count, buffer, format, &(struct args){.dummy = 0, __VA_ARGS__});

static inline int
sprintf(uint64_t const count, char buffer[count], char const format[static 1], struct args *args)
{
        uint64_t offset = 0;
        uint64_t arg = 0;
        for (uint64_t i = 0; format[i] != '\0' && offset + 1 < count;) {
                if (format[i] != '%') {
                        buffer[offset++] = format[i++];
                        continue;
                }
                if (format[i + 1] == 'd') {
                        uint64_t num = args->data[arg].num;
                        ++arg;
                        char const decimal[] = "0123456789";
                        char tmp[17] = {'0', '\0'};
                        for (int j = 0; num > 0; ++j) {
                                tmp[j] = decimal[(num%10)];
                                num /= 10;
                        }

                        // copy to buffer
                        int len = 0;
                        while (tmp[len] != '\0') ++len;

                        // reverse
                        for (int j = len; j-- > 0 && offset + 1 < count;)
                                buffer[offset++] = tmp[j];
                        i += 2;
                }

                if (format[i + 1] == 'x') {
                        uint64_t num = args->data[arg].num;
                        ++arg;

                        char const hex[] = "0123456789ABCDEF";
                        char tmp[17] = {'0', '\0'};
                        for (int j = 0; num > 0; ++j) {
                                tmp[j] = hex[(num%16)];
                                num /= 16;
                        }

                        // copy to buffer
                        int len = 0;
                        while (tmp[len] != '\0') ++len;

                        // reverse
                        for (int j = len; j-- > 0 && offset + 1 < count;)
                                buffer[offset++] = tmp[j];
                        i += 2;
                }

                if (format[i + 1] == 's') {
                        char *ptr = args->data[arg].str;
                        ++arg;
                        for (int j = 0; ptr[j] != '\0' && offset + 1 < count; ++j)
                                buffer[offset++] = ptr[j];
                        i += 2;
                }

        }
        buffer[offset] = '\0';
        return 0;
}


#endif
