#ifndef SYSCALL_H
#define SYSCALL_H

#include "type.h"


int64_t
syscall_logc(char c);


// TODO: return error code somehow (multiple arg return via rdx?)
int64_t
syscall_container_alloc(uint64_t container_idx, uint64_t rip, uint64_t rsp,
                        uint64_t de_fault, uint64_t pf_fault, uint64_t xf_fault);

int64_t
syscall_container_free(uint64_t container_idx);

int64_t
syscall_quanta_alloc(uint64_t core_idx, uint64_t container_idx, uint64_t count, uint64_t timer_interrupt);

int64_t
syscall_quanta_yield(uint64_t core_idx, uint64_t container_idx, uint64_t count);

int64_t
syscall_frame_alloc(uint64_t container_idx, uint64_t idx, uint64_t key);

// TODO: pass capability
int64_t
syscall_map(uint64_t container_idx, uint64_t va_start, uint64_t pa, uint64_t size, uint64_t perm, uint64_t hash);


#endif
