OUTPUT_FORMAT(elf64-x86-64)
OUTPUT_ARCH(i386:x86-64)
ENTRY(_start)


/* by default linker would put .text and .rodata into one read and execute segment */
PHDRS
{
        text    PT_LOAD FLAGS(5); /* read and execute */
        rodata  PT_LOAD FLAGS(4); /* read */
        data    PT_LOAD FLAGS(6); /* read and write */
}

SECTIONS
{
        . = 0x200000; /* leave a guard page (for NULL pointer) */

        . = ALIGN(0x200000);
        .text : {
                *(.text)
        } : text

        . = ALIGN(0x200000);
        .rodata : {
                *(.rodata*) /* TODO: why asterisk at the end? */
        } : rodata

        . = ALIGN(0x200000);
        .data : {
                *(.data)
        } : data

        /* I don't like .bss */
        .bss : {
                *(COMMON)
                *(.bss)
        }

        /DISCARD/ : {
                *(.comment .eh_frame)
        }
}
